SystemOrganization addCategory: #'Arduino-EtoysCompiler'!

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:05'!
detectMainMorph
	^ self! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 10/24/2011 12:50'!
download: anArduinoCTranslatedProgram
	anArduinoCTranslatedProgram 
		uploadOnPort: portName 
		arduinoType: (ArduinoType withFriendlyName: boardType)! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
playerTranslator
	^ ArduinoPlayerTranslator on: self! !

ArduinoSketch subclass: #ArduinoEtoysSketch
	instanceVariableNames: 'pin3 pin4 pin5 pin6 pin7 pin8 pin9 pin10 pin11 pin12 pin13 pin14 pin15 pin16 pin17 pin18 pin19 mode3 mode4 mode5 mode6 mode7 mode8 mode9 mode10 mode11 mode12 mode13 mode14 mode15 mode16 mode17 mode18 mode19'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoEtoysSketch commentStamp: 'Richo 10/24/2011 12:23' prior: 0!
I'm the superclass of all Arduino Etoys programs, I add a lot of useful methods and inst vars to correctly handle the values and modes of all the pins.

Although this class is awfully big and redundant, all its methods have been automatically generated (see class side) and only the methods called will be translated.!

!ArduinoEtoysSketch class methodsFor: 'class initialization' stamp: 'Richo 10/24/2011 12:48'!
addInstVars
	"
	self addInstVars.
	"
	| names types |
	names := WriteStream on: ''.
	types := WriteStream on: #().
	"pins"
	3 to: 19 do: [:i |
		names nextPutAll: 'pin', i asString; space.
		types nextPut: #CLong.
	].
	"modes"
	3 to: 19 do: [:i |
		names nextPutAll: 'mode', i asString; space.
		types nextPut: #CByte.
	].

	ArduinoSketch subclass: #ArduinoEtoysSketch
		instanceVariableNames: names contents
		instanceVariableTypes: types contents
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Arduino-EtoysCompiler'! !

!ArduinoEtoysSketch class methodsFor: 'class initialization' stamp: 'Richo 10/24/2011 12:44'!
generateMethods
"
	self generateMethods
"
| setter digitalGetter analogGetter modeSetter modeGetter boolGetter boolSetter |
setter := 'pin{1}: aNumber
	<argTypes: #(CLong)>
	pin{1} := aNumber.
	mode{1} = 1 "Out"
		ifTrue: [self digitalWrite: {1} value: aNumber].
	mode{1} = 2 "Pwm"
		ifTrue: [self analogWrite: {1} value: aNumber]'.

digitalGetter := 'pin{1}
	<returnType: #(CLong)>
	mode{1} = 0 "Input"
		ifTrue: [^ self digitalRead: {1}]
		ifFalse: [^ pin{1}] '.

analogGetter := 'pin{1}
	<returnType: #(CLong)>
	mode{1} = 0 "Input"
		ifTrue: [^ self analogRead: {1}]
		ifFalse: [^ pin{1}] '.

boolGetter := 'pin{1}Bool
	<returnType: #(CBoolean)>
	^ self pin{1} ~= 0'.

boolSetter := 'pin{1}Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin{1}: 1]
		ifFalse: [self pin{1}: 0]'.

modeSetter := 'mode{1}: aNumber
	<argTypes: #(CByte)>
	mode{1} := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: {1} mode: 0]
		ifFalse: [self pin: {1} mode: 1]'.

modeGetter := 'mode{1}
	<returnType: #(CByte)>
	^ mode{1}'.

3 to: 19 do: [:i |
	self compile: (setter format: {i asString})
		classified: #accessing.
	self compile: ((i > 13 ifTrue: [analogGetter] ifFalse: [digitalGetter]) format: {i asString})
		classified: #accessing.
	self compile: (boolGetter format: {i asString})
		classified: #accessing.
	self compile: (boolSetter format: {i asString})
		classified: #accessing.
	self compile: (modeSetter format: {i asString})
		classified: #accessing.
	self compile: (modeGetter format: {i asString})
		classified: #accessing.
].! !

!ArduinoEtoysSketch class methodsFor: 'definition' stamp: 'Richo 10/24/2011 12:48'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CLong #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte #CByte)! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode10
	<returnType: #(CByte)>
	^ mode10! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode10: aNumber
	<argTypes: #(CByte)>
	mode10 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 10 mode: 0]
		ifFalse: [self pin: 10 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode11
	<returnType: #(CByte)>
	^ mode11! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode11: aNumber
	<argTypes: #(CByte)>
	mode11 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 11 mode: 0]
		ifFalse: [self pin: 11 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode12
	<returnType: #(CByte)>
	^ mode12! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode12: aNumber
	<argTypes: #(CByte)>
	mode12 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 12 mode: 0]
		ifFalse: [self pin: 12 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode13
	<returnType: #(CByte)>
	^ mode13! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode13: aNumber
	<argTypes: #(CByte)>
	mode13 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 13 mode: 0]
		ifFalse: [self pin: 13 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode14
	<returnType: #(CByte)>
	^ mode14! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode14: aNumber
	<argTypes: #(CByte)>
	mode14 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 14 mode: 0]
		ifFalse: [self pin: 14 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode15
	<returnType: #(CByte)>
	^ mode15! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode15: aNumber
	<argTypes: #(CByte)>
	mode15 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 15 mode: 0]
		ifFalse: [self pin: 15 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode16
	<returnType: #(CByte)>
	^ mode16! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode16: aNumber
	<argTypes: #(CByte)>
	mode16 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 16 mode: 0]
		ifFalse: [self pin: 16 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode17
	<returnType: #(CByte)>
	^ mode17! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode17: aNumber
	<argTypes: #(CByte)>
	mode17 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 17 mode: 0]
		ifFalse: [self pin: 17 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode18
	<returnType: #(CByte)>
	^ mode18! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode18: aNumber
	<argTypes: #(CByte)>
	mode18 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 18 mode: 0]
		ifFalse: [self pin: 18 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode19
	<returnType: #(CByte)>
	^ mode19! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode19: aNumber
	<argTypes: #(CByte)>
	mode19 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 19 mode: 0]
		ifFalse: [self pin: 19 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode3
	<returnType: #(CByte)>
	^ mode3! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode3: aNumber
	<argTypes: #(CByte)>
	mode3 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 3 mode: 0]
		ifFalse: [self pin: 3 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode4
	<returnType: #(CByte)>
	^ mode4! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode4: aNumber
	<argTypes: #(CByte)>
	mode4 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 4 mode: 0]
		ifFalse: [self pin: 4 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode5
	<returnType: #(CByte)>
	^ mode5! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode5: aNumber
	<argTypes: #(CByte)>
	mode5 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 5 mode: 0]
		ifFalse: [self pin: 5 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode6
	<returnType: #(CByte)>
	^ mode6! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode6: aNumber
	<argTypes: #(CByte)>
	mode6 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 6 mode: 0]
		ifFalse: [self pin: 6 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode7
	<returnType: #(CByte)>
	^ mode7! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode7: aNumber
	<argTypes: #(CByte)>
	mode7 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 7 mode: 0]
		ifFalse: [self pin: 7 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode8
	<returnType: #(CByte)>
	^ mode8! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode8: aNumber
	<argTypes: #(CByte)>
	mode8 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 8 mode: 0]
		ifFalse: [self pin: 8 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode9
	<returnType: #(CByte)>
	^ mode9! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
mode9: aNumber
	<argTypes: #(CByte)>
	mode9 := aNumber.
	aNumber = 0 "Input"
		ifTrue: [self pin: 9 mode: 0]
		ifFalse: [self pin: 9 mode: 1]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin10
	<returnType: #(CLong)>
	mode10 = 0 "Input"
		ifTrue: [^ self digitalRead: 10]
		ifFalse: [^ pin10] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin10: aNumber
	<argTypes: #(CLong)>
	pin10 := aNumber.
	mode10 = 1 "Out"
		ifTrue: [self digitalWrite: 10 value: aNumber].
	mode10 = 2 "Pwm"
		ifTrue: [self analogWrite: 10 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin10Bool
	<returnType: #(CBoolean)>
	^ self pin10 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin10Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin10: 1]
		ifFalse: [self pin10: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin11
	<returnType: #(CLong)>
	mode11 = 0 "Input"
		ifTrue: [^ self digitalRead: 11]
		ifFalse: [^ pin11] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin11: aNumber
	<argTypes: #(CLong)>
	pin11 := aNumber.
	mode11 = 1 "Out"
		ifTrue: [self digitalWrite: 11 value: aNumber].
	mode11 = 2 "Pwm"
		ifTrue: [self analogWrite: 11 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin11Bool
	<returnType: #(CBoolean)>
	^ self pin11 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin11Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin11: 1]
		ifFalse: [self pin11: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin12
	<returnType: #(CLong)>
	mode12 = 0 "Input"
		ifTrue: [^ self digitalRead: 12]
		ifFalse: [^ pin12] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin12: aNumber
	<argTypes: #(CLong)>
	pin12 := aNumber.
	mode12 = 1 "Out"
		ifTrue: [self digitalWrite: 12 value: aNumber].
	mode12 = 2 "Pwm"
		ifTrue: [self analogWrite: 12 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin12Bool
	<returnType: #(CBoolean)>
	^ self pin12 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin12Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin12: 1]
		ifFalse: [self pin12: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin13
	<returnType: #(CLong)>
	mode13 = 0 "Input"
		ifTrue: [^ self digitalRead: 13]
		ifFalse: [^ pin13] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin13: aNumber
	<argTypes: #(CLong)>
	pin13 := aNumber.
	mode13 = 1 "Out"
		ifTrue: [self digitalWrite: 13 value: aNumber].
	mode13 = 2 "Pwm"
		ifTrue: [self analogWrite: 13 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin13Bool
	<returnType: #(CBoolean)>
	^ self pin13 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin13Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin13: 1]
		ifFalse: [self pin13: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin14
	<returnType: #(CLong)>
	mode14 = 0 "Input"
		ifTrue: [^ self analogRead: 14]
		ifFalse: [^ pin14] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin14: aNumber
	<argTypes: #(CLong)>
	pin14 := aNumber.
	mode14 = 1 "Out"
		ifTrue: [self digitalWrite: 14 value: aNumber].
	mode14 = 2 "Pwm"
		ifTrue: [self analogWrite: 14 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin14Bool
	<returnType: #(CBoolean)>
	^ self pin14 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin14Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin14: 1]
		ifFalse: [self pin14: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin15
	<returnType: #(CLong)>
	mode15 = 0 "Input"
		ifTrue: [^ self analogRead: 15]
		ifFalse: [^ pin15] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin15: aNumber
	<argTypes: #(CLong)>
	pin15 := aNumber.
	mode15 = 1 "Out"
		ifTrue: [self digitalWrite: 15 value: aNumber].
	mode15 = 2 "Pwm"
		ifTrue: [self analogWrite: 15 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin15Bool
	<returnType: #(CBoolean)>
	^ self pin15 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin15Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin15: 1]
		ifFalse: [self pin15: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin16
	<returnType: #(CLong)>
	mode16 = 0 "Input"
		ifTrue: [^ self analogRead: 16]
		ifFalse: [^ pin16] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin16: aNumber
	<argTypes: #(CLong)>
	pin16 := aNumber.
	mode16 = 1 "Out"
		ifTrue: [self digitalWrite: 16 value: aNumber].
	mode16 = 2 "Pwm"
		ifTrue: [self analogWrite: 16 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin16Bool
	<returnType: #(CBoolean)>
	^ self pin16 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin16Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin16: 1]
		ifFalse: [self pin16: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin17
	<returnType: #(CLong)>
	mode17 = 0 "Input"
		ifTrue: [^ self analogRead: 17]
		ifFalse: [^ pin17] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin17: aNumber
	<argTypes: #(CLong)>
	pin17 := aNumber.
	mode17 = 1 "Out"
		ifTrue: [self digitalWrite: 17 value: aNumber].
	mode17 = 2 "Pwm"
		ifTrue: [self analogWrite: 17 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin17Bool
	<returnType: #(CBoolean)>
	^ self pin17 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin17Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin17: 1]
		ifFalse: [self pin17: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin18
	<returnType: #(CLong)>
	mode18 = 0 "Input"
		ifTrue: [^ self analogRead: 18]
		ifFalse: [^ pin18] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin18: aNumber
	<argTypes: #(CLong)>
	pin18 := aNumber.
	mode18 = 1 "Out"
		ifTrue: [self digitalWrite: 18 value: aNumber].
	mode18 = 2 "Pwm"
		ifTrue: [self analogWrite: 18 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin18Bool
	<returnType: #(CBoolean)>
	^ self pin18 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin18Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin18: 1]
		ifFalse: [self pin18: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin19
	<returnType: #(CLong)>
	mode19 = 0 "Input"
		ifTrue: [^ self analogRead: 19]
		ifFalse: [^ pin19] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin19: aNumber
	<argTypes: #(CLong)>
	pin19 := aNumber.
	mode19 = 1 "Out"
		ifTrue: [self digitalWrite: 19 value: aNumber].
	mode19 = 2 "Pwm"
		ifTrue: [self analogWrite: 19 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin19Bool
	<returnType: #(CBoolean)>
	^ self pin19 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin19Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin19: 1]
		ifFalse: [self pin19: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin3
	<returnType: #(CLong)>
	mode3 = 0 "Input"
		ifTrue: [^ self digitalRead: 3]
		ifFalse: [^ pin3] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin3: aNumber
	<argTypes: #(CLong)>
	pin3 := aNumber.
	mode3 = 1 "Out"
		ifTrue: [self digitalWrite: 3 value: aNumber].
	mode3 = 2 "Pwm"
		ifTrue: [self analogWrite: 3 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin3Bool
	<returnType: #(CBoolean)>
	^ self pin3 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin3Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin3: 1]
		ifFalse: [self pin3: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin4
	<returnType: #(CLong)>
	mode4 = 0 "Input"
		ifTrue: [^ self digitalRead: 4]
		ifFalse: [^ pin4] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin4: aNumber
	<argTypes: #(CLong)>
	pin4 := aNumber.
	mode4 = 1 "Out"
		ifTrue: [self digitalWrite: 4 value: aNumber].
	mode4 = 2 "Pwm"
		ifTrue: [self analogWrite: 4 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin4Bool
	<returnType: #(CBoolean)>
	^ self pin4 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin4Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin4: 1]
		ifFalse: [self pin4: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin5
	<returnType: #(CLong)>
	mode5 = 0 "Input"
		ifTrue: [^ self digitalRead: 5]
		ifFalse: [^ pin5] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin5: aNumber
	<argTypes: #(CLong)>
	pin5 := aNumber.
	mode5 = 1 "Out"
		ifTrue: [self digitalWrite: 5 value: aNumber].
	mode5 = 2 "Pwm"
		ifTrue: [self analogWrite: 5 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin5Bool
	<returnType: #(CBoolean)>
	^ self pin5 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin5Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin5: 1]
		ifFalse: [self pin5: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin6
	<returnType: #(CLong)>
	mode6 = 0 "Input"
		ifTrue: [^ self digitalRead: 6]
		ifFalse: [^ pin6] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin6: aNumber
	<argTypes: #(CLong)>
	pin6 := aNumber.
	mode6 = 1 "Out"
		ifTrue: [self digitalWrite: 6 value: aNumber].
	mode6 = 2 "Pwm"
		ifTrue: [self analogWrite: 6 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin6Bool
	<returnType: #(CBoolean)>
	^ self pin6 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin6Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin6: 1]
		ifFalse: [self pin6: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin7
	<returnType: #(CLong)>
	mode7 = 0 "Input"
		ifTrue: [^ self digitalRead: 7]
		ifFalse: [^ pin7] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin7: aNumber
	<argTypes: #(CLong)>
	pin7 := aNumber.
	mode7 = 1 "Out"
		ifTrue: [self digitalWrite: 7 value: aNumber].
	mode7 = 2 "Pwm"
		ifTrue: [self analogWrite: 7 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin7Bool
	<returnType: #(CBoolean)>
	^ self pin7 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin7Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin7: 1]
		ifFalse: [self pin7: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin8
	<returnType: #(CLong)>
	mode8 = 0 "Input"
		ifTrue: [^ self digitalRead: 8]
		ifFalse: [^ pin8] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin8: aNumber
	<argTypes: #(CLong)>
	pin8 := aNumber.
	mode8 = 1 "Out"
		ifTrue: [self digitalWrite: 8 value: aNumber].
	mode8 = 2 "Pwm"
		ifTrue: [self analogWrite: 8 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin8Bool
	<returnType: #(CBoolean)>
	^ self pin8 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin8Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin8: 1]
		ifFalse: [self pin8: 0]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin9
	<returnType: #(CLong)>
	mode9 = 0 "Input"
		ifTrue: [^ self digitalRead: 9]
		ifFalse: [^ pin9] ! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin9: aNumber
	<argTypes: #(CLong)>
	pin9 := aNumber.
	mode9 = 1 "Out"
		ifTrue: [self digitalWrite: 9 value: aNumber].
	mode9 = 2 "Pwm"
		ifTrue: [self analogWrite: 9 value: aNumber]! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin9Bool
	<returnType: #(CBoolean)>
	^ self pin9 ~= 0! !

!ArduinoEtoysSketch methodsFor: 'accessing' stamp: 'Richo 10/24/2011 12:47'!
pin9Bool: aBoolean
	<argTypes: #(CBoolean)>
	aBoolean
		ifTrue: [self pin9: 1]
		ifFalse: [self pin9: 0]! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/23/2011 16:16'!
getArduinoMode
	^ self costume renderedMorph mode nameSymbol! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
isUsingCompiledMode
	"An error might be signaled if this message is sent to an unplugged device"
	^ [self costume renderedMorph detectMainMorph isUsingCompiledMode] on: Error do: [false]! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
newScriptorAround: aPhrase
	| scriptEditor |
	Transcript show: 'newScriptorAround:'; cr.
	^ scriptEditor := super newScriptorAround: aPhrase.
	"^ NxtScriptEditorMorph fromScriptEditor: scriptEditor phrase: aPhrase"! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorFor: aSelector
	Transcript show: 'scriptEditorFor:'; cr.
	^ super scriptEditorFor: aSelector! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorForNoCng: aSelector
	Transcript show: 'scriptEditorForNoCng:'; cr.
	^ super scriptEditorForNoCng: aSelector.! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/23/2011 16:17'!
setArduinoMode: aSymbol
	self getArduinoMode = aSymbol ifTrue: [^self].
	self costume renderedMorph
		mode: (aSymbol caseOf: {
			[#firmata] -> [Firmata new].
			[#direct] -> [ArduinoDirectMode new].
			[#compiled] -> [ArduinoCompiledMode new].
			} otherwise: [^self]).

	"Horrible hack below"
	World allMorphsDo: [:morph | | viewer |
		"Update scripts category of all opened viewers"
		((morph isKindOf: StandardViewer) and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph updateScriptsCategory].
		"Also update closed viewers"
		((morph isKindOf: ViewerFlapTab) and: [(viewer := morph referent findA: StandardViewer) notNil])
			ifTrue: [viewer updateScriptsCategory].
		"Finally, update all opened script editors"
		((morph isKindOf: ScriptEditorMorph) and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph replaceRow1; minWidth: nil]]! !

ArduinoProtocol subclass: #ArduinoCompiledMode
	instanceVariableNames: 'isConnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
activateAnalogPin: pinNumber
"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
activateDigitalPort: portNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
analogRead: pinNumber
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/27/2011 15:31'!
analogWrite: pin value: value
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
attachServoToPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:39'!
connectOnPort: portName boardType: anArduinoType
	isConnected := true! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
deactivateAnalogPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
deactivateDigitalPort: portNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
detachServoFromPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
digitalPin: pinNumber mode: mode
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
digitalRead: pinNumber
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:39'!
digitalWrite: pinNumber value: value
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:39'!
disconnect
	isConnected := false! !

!ArduinoCompiledMode methodsFor: 'testing' stamp: 'Richo 12/23/2011 15:11'!
isCompiled
	^ true! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:45'!
isConnected
	^ isConnected ifNil: [false]! !

!ArduinoCompiledMode methodsFor: 'accessing' stamp: 'Richo 12/23/2011 16:29'!
nameSymbol
	^ #compiled! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
servoOnPin: pinNumber angle: degrees
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForInputMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForOutputMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForPwmMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForServoMode
	"Do nothing"
	^ 0! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 12:58'!
detectMainMorph
	"Looks for the arduino board in which it is connected and returns it"
	World allMorphsDo: [:morph |
		((morph isKindOf: ArduinoMorph) and: [self isAttachedTo: morph])
			ifTrue: [^ morph]
		].
	^ self error: 'The device is not properly attached to any arduino'! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 10:21'!
download: anArduinoCTranslatedProgram
	^ self detectMainMorph download: anArduinoCTranslatedProgram! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 16:20'!
isAttachedTo: anArduinoMorph 
	^ device isAttachedToArduino: anArduinoMorph arduino! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 10:21'!
playerTranslator
	^ self detectMainMorph playerTranslator! !

RBProgramNodeVisitor subclass: #ArduinoPlayerTranslator
	instanceVariableNames: 'mainMorph currentMorph methods digitalPins analogPins variables getterSelectors setterSelectors scriptSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoPlayerTranslator class methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:06'!
allPrimitiveRulesSelectors
	^ Array streamContents: [:stream |
		"Collect all primitives in the ArduinoSketch protocol..."
		(Pragma allNamed: #c: from: ArduinoSketch to: CObject)
			do: [:pragma | stream nextPut: pragma method selector].
		"... and in all the primitive types' protocol as well"
		CPrimitiveType withAllSubclassesDo: [:each |
			(Pragma allNamed: #c: in: each)
				do: [:pragma | stream nextPut: pragma method selector]]]! !

!ArduinoPlayerTranslator class methodsFor: 'instance creation' stamp: 'Richo 8/11/2011 17:21'!
on: anArduinoMorph 
	^ self basicNew
			initializeWith: anArduinoMorph;
			yourself! !

!ArduinoPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 8/16/2011 13:04'!
acceptMessageNode: aMessageNode 
	| selector |
	selector := aMessageNode selector.
	"Check for invalid selector or invalid receiver"
	self assert: [self isValidSelector: selector];		
		assert: [self isValidReceiver: aMessageNode receiver].
	"Is it a rule?"
	(self rules includesKey: selector)
		ifTrue: [^(self rules at: selector)
				value: aMessageNode].
	"Is it an etoys message?"
	(self etoysMessages includesKey: selector)
		ifTrue: [(self etoysMessages at: selector)
				value: aMessageNode].
	"Is it a getter?"
	(self allGetterSelectors includes: selector)
		ifTrue: [| newNode | 
			self
				withCurrentMorph: (self morphFor: aMessageNode receiver name)
				do: [newNode := self variable: (self slotForGetter: selector)].
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	"Is it a setter?"
	(self allSetterSelectors includes: selector)
		ifTrue: [| newNode | 
			self
				withCurrentMorph: (self morphFor: aMessageNode receiver name)
				do: [newNode := RBAssignmentNode
								variable: (self variable: (self slotForSetter: selector))
								value: aMessageNode arguments first].
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	"Is it a script call?"
	(self allScriptSelectors includes: selector)
		ifTrue: [self
				withCurrentMorph: (self morphFor: aMessageNode receiver name)
				do: ["Check for recursive call"
					self assert: [self isNotRecursiveCall: aMessageNode].
					aMessageNode
						selector: (self asLegalName: aMessageNode selector);
						
						receiver: (self variable: 'self')]].
	"We still need to visit the receiver and the arguments"
	^ super acceptMessageNode: aMessageNode! !

!ArduinoPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 8/16/2011 13:03'!
acceptMethodNode: aMethodNode 
	"It goes over the method's arguments adding the #argTypes: pragma if necessary and modifies the selector to have a legal name"
	aMethodNode allArgumentVariables size = 1 
		ifTrue: [| varType | 
			varType := self asArduinoType: (self currentPlayerClass scripts at: aMethodNode selector) argumentVariables first variableType.
			aMethodNode pragmas: (RBParser parseMethod: 'm <argTypes: #(' , varType , ')>') pragmas].
	aMethodNode
		selector: (self asLegalName: aMethodNode selector).
	^ super acceptMethodNode: aMethodNode! !

!ArduinoPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 8/16/2011 13:03'!
acceptSequenceNode: aSequenceNode
	"If one of the statements has an invalid tile it will ignore it entirely. Only assertion failures will be ignored, other errors will be signaled, though"
	aSequenceNode statements do: [:each | [self visitNode: each] on: AssertionFailure do: [self becomeNoOp: each]]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:07'!
allGetterSelectors
	^ getterSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/15/2011 16:35'!
allMorphs
	"Returns a collection with all the morphs composing the robot (it could contain nils)"
	^ {mainMorph}, 
		digitalPins values flattened, 
		analogPins values flattened! !

!ArduinoPlayerTranslator methodsFor: 'iterating' stamp: 'Richo 8/15/2011 16:24'!
allMorphsDo: aBlock
	"Iterates over all morphs composing the robot taking care of posible nil occurrences"
	self allMorphs do: [:each |
		each notNil ifTrue: [aBlock value: each]
	]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:08'!
allScriptSelectors
	^ scriptSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:08'!
allSetterSelectors
	^ setterSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/24/2011 13:53'!
arduinoIndexOf: aVariableNode
	^ [self arduinoIndexOf: aVariableNode in: digitalPins]
		on: Error
		do: [:ign |
			14 + (self arduinoIndexOf: aVariableNode in: analogPins)]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/21/2011 20:38'!
arduinoIndexOf: aVariableNode in: aCollection
	"Basically, it tries to determine if the variable node is representing an object in the collection. If it is, it returns its index"
	| index findIndex |
	findIndex := [:morph || ret |
		ret := nil.
		aCollection keysAndValuesDo: [:key :value |
			(value includes: morph)
				ifTrue: [ret := key]
			].
		ret].
	aVariableNode name = 'self' 
		ifTrue: [index := findIndex value: currentMorph]
		ifFalse: [index := findIndex value: (self morphFor: aVariableNode name)].
	^ index isNil ifTrue: [self error: 'Index not found'] ifFalse: [index].
! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:57'!
asArduinoType: aSymbol
	"If the type is not valid just return the symbol. Hack to allow #firstTick to have #u32 type"
	^ aSymbol caseOf: {
		[#Number] -> [#CLong].
		[#Boolean] -> [#CBoolean].
		[#String] -> [#CString]
		} otherwise: [aSymbol]! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:22'!
asLegalName: aString
"All variables, method names and task names must begin with a prefix representing the receiver."
^ currentMorph assuredPlayer uniqueNameForReference asLegalSelector, aString capitalized! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:21'!
asLegalScriptFlag: aSymbol 
	"Returns the name of the flag variable used to stop this script"
	^ self asLegalName: (self asScriptFlag: aSymbol)! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:22'!
asLegalScriptLastTime: aByteSymbol 
	^ self asLegalName: (self asScriptLastTime: aByteSymbol)! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:21'!
asScriptFlag: aSymbol
	"Returns the name of the flag variable used to stop this script"
	^ (self asScriptName: aSymbol), 'Stepping'! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:23'!
asScriptLastTime: aSymbol
	^ aSymbol , 'LastTime'! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 12:21'!
asScriptName: aSymbol
	"Returns the name of this script"
	^ aSymbol, 'Script'! !

!ArduinoPlayerTranslator methodsFor: 'converting' stamp: 'Richo 8/16/2011 13:09'!
becomeNoOp: aParseNode
	"Transforms the argument in an empty statement:
	
	self c: ''.
	"
	| noOp |
	noOp := RBMessageNode receiver: (self variable: 'self') selector: #c: arguments: {self literal: ''}.
	aParseNode become: (noOp parent: aParseNode parent)! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 8/15/2011 16:23'!
collectDevices
	"Finds out which device morphs are connected to the arduino in which pins (digital or analog).
	It's not the cleanest way of doing it but it works..."
	| arduino |
	arduino := mainMorph arduino.
	digitalPins := ((2 to: 13)
		collect: [:n | n -> OrderedCollection new]) as: Dictionary.
	analogPins := ((0 to: 5)
		collect: [:n | n -> OrderedCollection new]) as: Dictionary.
	World allMorphsDo: [:morph |
		((morph isKindOf: AttachableDeviceMorph)
		and: [morph isAttachedTo: mainMorph])
			ifTrue: [
				arduino digitalPins do: [:pin |
					(morph device isAttachedToPin: pin)
						ifTrue: [(digitalPins at: pin number) add: morph]
				].
				arduino analogPins do: [:pin |
					(morph device isAttachedToPin: pin)
						ifTrue: [(analogPins at: pin number) add: morph]
				]
		]
	]! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:30'!
collectGetterSelectors
	"Collects all selectors corresponding to a slot getter in a dictionary whose keys are the morphs owning the slot"
	getterSelectors := Dictionary new.
	self allMorphsDo: [:morph | | selectors |
		selectors := getterSelectors at: morph ifAbsentPut: [OrderedCollection new].
		selectors addAll: (morph assuredPlayer slotInfo keys collect: [:selector | Utilities getterSelectorFor: selector])].
! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 8/15/2011 13:04'!
collectRelevantInformation
	self collectDevices; 
		 collectSlots;
		 collectGetterSelectors;
		 collectSetterSelectors;
		 collectScriptSelectors! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:30'!
collectScriptSelectors
	"Collects all selectors corresponding to a script in a dictionary whose keys are the morphs owning the methods"
	scriptSelectors := Dictionary new.
	self
		allMorphsDo: [:morph | 
			| selectors | 
			selectors := scriptSelectors
						at: morph
						ifAbsentPut: [OrderedCollection new].
			selectors
				addAll: (morph assuredPlayer class selectors
						reject: [:selector | ((getterSelectors at: morph)
									includes: selector)
								or: [(setterSelectors at: morph)
										includes: selector]])] ! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:31'!
collectSetterSelectors
	"Collects all selectors corresponding to a slot setter in a dictionary whose keys are the morphs owning the slot"
	setterSelectors := Dictionary new.
	self allMorphsDo: [:morph | | selectors |
		selectors := setterSelectors at: morph ifAbsentPut: [OrderedCollection new].
		selectors addAll: (morph assuredPlayer slotInfo keys collect: [:selector | Utilities setterSelectorFor: selector])].
! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:32'!
collectSlots
	"Adds all the slots and they respective types to the variables dictionary."
	variables := Dictionary new.
	self allMorphsDo: [:morph | | slots |
		slots := variables at: morph ifAbsentPut: [Dictionary new].
		morph assuredPlayer slotInfo 
			keysAndValuesDo: [:slotName :slotInfo | 
				slots at: slotName put: (slotInfo type -> (morph assuredPlayer instVarNamed: slotName))]]! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 12/27/2011 15:43'!
commonDevicesRules
| selfVar |
selfVar := self variable: 'self'.
^ {
"LED"
#getIsLedOn -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString, #Bool) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node].
#setIsLedOn: -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node selector: (#pin , (self arduinoIndexOf: node receiver) asString, #Bool:) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node].

"Pushbutton"
#getIsPressed -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString, #Bool) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].

"Photoresistor"
#getLightValue -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].

"Potentiometer"
#getPotentiometerValue -> [:node |
		self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].

"Thermistor"
#getTemperatureValue -> [:node |
		self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].


"Servo"
#setDegrees: -> [:node | 
	self flag: #Richo. "Use servo library instead of analogWrite()"
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node selector: (#pin , (self arduinoIndexOf: node receiver) asString, #:) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node].

"Pwm led"
#setLedValue: -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node selector: (#pin , (self arduinoIndexOf: node receiver) asString, #:) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node].
#getLedValue -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].

"Buzzer"
#setBuzzerValue:  -> [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node selector: (#pin , (self arduinoIndexOf: node receiver) asString, #:) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node].
#getBuzzerValue -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: #();
			selector: (#pin , (self arduinoIndexOf: node receiver) asString) asSymbol;
			receiver: selfVar].
	super acceptMessageNode: node
].
}! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 8/16/2011 12:20'!
compileLoopMethod
	methods add: (String streamContents: [:stream |
		stream nextPutAll: 'loop
	| now |
	<tempTypes: #(CUnsignedLong)>
	now := self millis.
	'.
	self scriptSelectorsDo: [:selector || code |
		code := '({1} and: [now - {2} > {3}])
		ifTrue: [{4} timesRepeat: [self {5}].
			{2} := now].' 
			format: {
				(self asLegalScriptFlag: selector).
				(self asLegalScriptLastTime: selector).
				(self delayOfScript: selector).
				(self frequencyOfScript: selector).
				(self asLegalName: selector)}.
		stream nextPutAll: code.
		]
	])! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 10/24/2011 16:07'!
compileSetUpMethod
| methodSource |
methodSource := WriteStream on: ''.
methodSource nextPutAll: 'setup'; cr.
"Configure sensors"
digitalPins keysAndValuesDo: [:key :value |
	value notEmpty
		ifTrue: [| mode |
		mode := (mainMorph arduino digitalPin: key) mode.
		methodSource
			nextPutAll: 'self mode';
			nextPutAll: key asString;
			nextPutAll: ':';
			space;
			nextPutAll: (true caseOf: {
				[mode isPwm] -> ['2'].
				[mode isOutput] -> ['1'].
				[mode isInput] -> ['0']
				});
			nextPutAll: '.';
			cr.
	]
].
analogPins keysAndValuesDo: [:key :value |
	value notEmpty
		ifTrue: [| mode |
		mode := (mainMorph arduino analogPin: key) mode.
		methodSource
			nextPutAll: 'self mode';
			nextPutAll: (key + 14) asString;
			nextPutAll: ':';
			space;
			nextPutAll: (true caseOf: {
				[mode isPwm] -> ['2'].
				[mode isOutput] -> ['1'].
				[mode isInput] -> ['0']
				});
			nextPutAll: '.';
			cr.
	]
].


"Initialize variables"
self variablesDo: [:varName :varTypeAndValue | | value |
	value := varTypeAndValue value.
	value := (value isKindOf: RBProgramNode) 
				ifTrue: [value formattedCode]  "Is a message send"
				ifFalse: [value printString]. "Is a literal"
	methodSource 
		nextPutAll: (self asLegalName: varName), ' := ' , value , '.';
		cr].
methods add: methodSource contents! !

!ArduinoPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 8/16/2011 12:27'!
compileTempProgramSubclass
	| instVarNames instVarTypes |
	instVarNames := ''.
	instVarTypes := #().
	"First collect all variables"
	self
		variablesDo: [:varName :varTypeAndValue | 
			instVarNames := instVarNames, (self asLegalName: varName) , ' '.
			instVarTypes := instVarTypes, {self asArduinoType: varTypeAndValue key}].
	"Then create the class"
	self createTempProgramSubclassInstVarNames: instVarNames
		 instVarTypes: instVarTypes.
	"Finally compile all methods"
	methods
		do: [:each | self programClass compileSilently: each classified: #autogenerated]! !

!ArduinoPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 10/21/2011 20:45'!
createTempProgramSubclassInstVarNames: aString instVarTypes: anArray 
	SystemChangeNotifier uniqueInstance doSilently: [
		ArduinoEtoysSketch subclass: self programName
			instanceVariableNames: aString
			instanceVariableTypes: anArray
			classVariableNames: ''
			poolDictionaries: ''
			category: 'ArduinoPrograms']! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/15/2011 16:53'!
currentPlayer
	^ currentMorph assuredPlayer! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/15/2011 16:53'!
currentPlayerClass
	^ self currentPlayer class! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 12:24'!
delayOfScript: scriptName
 	"To be in accordance with the script tick rate, we put a delay at the end of each task. How long the delay would be?"
	^ (1000 / (self currentPlayer scriptInstantiationForSelector: scriptName) tickingRate) rounded asString! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:07'!
etoysMessages
^ {
"#grouped actually doesn't do anything so we just take it out"
#grouped -> [:node | node become: (node receiver parent: node parent)].

"I don't know why but recent versions of Etoys use this weird messages instead of the comparison operators:"
#eToysLT: -> [:node | node selector: #<].
#eToysLE: -> [:node | node selector: #<=].
#eToysEQ: -> [:node | node selector: #=].
#eToysNE: -> [:node | node selector: #~=].
#eToysGT: -> [:node | node selector: #>].
#eToysGE: -> [:node | node selector: #>=].
} as: Dictionary! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 12:24'!
frequencyOfScript: scriptName
	"To be in accordance with the script frequency property we enclose the script call in a #timesRepeat: message. How many times should we repeat the script?"
	^ (self currentPlayer scriptInstantiationForSelector: scriptName) frequency rounded asString! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/21/2011 19:15'!
hashString
	^ self hash asString! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:33'!
initialize
	super initialize.
	self collectRelevantInformation! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 8/11/2011 17:23'!
initializeWith: anArduinoMorph
	"By default we set the brick as the currentMorph"
	mainMorph := currentMorph := anArduinoMorph.
	self initialize! !

!ArduinoPlayerTranslator methodsFor: 'testing' stamp: 'Richo 8/16/2011 13:10'!
isValidReceiver: aParseNode 
	"If the parse node is a variable it *must* be one of the valid morphs or an argument variable. I'm not sure about this, actually so we might have to test it more"
	| res |
	aParseNode isVariable
		ifTrue: [res := (aParseNode methodNode allArgumentVariables
							anySatisfy: [:each | each = aParseNode name])
						or: [(self morphFor: aParseNode name) notNil].
			res
				ifFalse: [self halt].
			^ res].
	^ true! !

!ArduinoPlayerTranslator methodsFor: 'testing' stamp: 'Richo 8/16/2011 13:05'!
isValidSelector: selector 
	"Checks if the selector is one of the following:
	* An arduino primitive rule.
	* A player translator rule
	* An etoys message.
	* A slot accessor.
	* A script selector."
	^ self class allPrimitiveRulesSelectors asSet , self rules keys , self etoysMessages keys , self allGetterSelectors , self allSetterSelectors , self allScriptSelectors includes: selector! !

!ArduinoPlayerTranslator methodsFor: 'creating parse nodes' stamp: 'Richo 8/16/2011 13:09'!
literal: aLiteralObject
	^ RBLiteralValueNode value: aLiteralObject! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 13:15'!
morphFor: receiverName
	"Returns the morph represented by the argument or nil if it's not a valid morph"
	^ receiverName = 'self'
		ifTrue: [currentMorph]
		ifFalse: [self allMorphs
				detect: [:each | each notNil and: [each assuredPlayer uniqueNameForReference = receiverName]] ifNone: [nil]]! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 12:25'!
programClass
	"Returns the temporary class we are using to compile the code"
	^ Smalltalk at: self programName ifAbsent: []! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 12:25'!
programName
	^ #ArduinoEtoysProgram! !

!ArduinoPlayerTranslator methodsFor: 'creating parse nodes' stamp: 'Richo 10/21/2011 17:11'!
receiver: receiverNode selector: selectorSymbol arguments: anArray
	^ RBMessageNode receiver: receiverNode selector: selectorSymbol arguments: anArray! !

!ArduinoPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 8/16/2011 12:25'!
removeTempProgramSubclass
	"After translation is done we silently remove the temporary class"
	SystemChangeNotifier uniqueInstance doSilently: [
		self programClass ifNotNilDo: [:class | class removeFromSystem]]! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 10/24/2011 14:32'!
rules
"These are the rules to modify the parse tree of the ArduinoPlayer scripts. Most of the time, I just need to rename the selector, change the receiver to self and set the correct list of arguments. Other times the rule is a little more complicated"
^ (
	self commonDevicesRules,
	self scriptingRules
	) as: Dictionary! !

!ArduinoPlayerTranslator methodsFor: 'iterating' stamp: 'Richo 8/15/2011 16:49'!
scriptSelectorsDo: aBlock 
	"Iterates over the scriptSelectors dictionary taking care of setting the current morph"
	scriptSelectors
		keysAndValuesDo: [:morph :selectors | self
				withCurrentMorph: morph
				do: [selectors do: aBlock]] ! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 10/24/2011 14:35'!
scriptingRules
| selfVar |
selfVar := self variable: 'self'.
^ {
#startScript: -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [	
		node arguments: {self literal: (self asLegalScriptFlag: node arguments first value), ' = true;'};
			 selector: #c:;
			 receiver: selfVar].
	super acceptMessageNode: node].

#stopScript: -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [	
		node arguments: {self literal: (self asLegalScriptFlag: node arguments first value), ' = false;'};
			 selector: #c:;
			 receiver: selfVar].
	super acceptMessageNode: node].

#pauseScript: -> [:node | "Do the same as #stopScript:"
	(self rules at: #stopScript:) value: node].

#doScript: -> [:node | | args | args := node arguments. "This is the same as calling the script directly"
	node arguments: #(); selector: args first value.
	self visitNode: node "We need to visit the node again to fix the selector and the receiver"]
}! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 10/24/2011 14:17'!
translateMainScript: scriptName of: scriptOwner
	"It translates the script to arduino c. It creates a temporary ArduinoCProgram subclass to hold the code which will be translated to c. After translation is done, it removes the temporary class.
	Steps:
	* Collect relevant information (motors and sensors composing the robot, slots, accessors and scripts).
	* Compile #setUp method.
	* Compile #main method.
	* Compile the script task.
	* Compile all scripts.
	* Remove temporary class.	
	* Compile temporary class.
	* Translate program to nxc
	* Return nxc program"
	self collectRelevantInformation.
	self
		assert: [self allMorphs includes: scriptOwner]
		description: 'The morph is not connected to the Arduino board';
		assert: [scriptOwner assuredPlayer class scripts includesKey: scriptName]
		description: 'The script doesn''t belong to the morph'.
	methods := Set new. 
	self
		scriptSelectorsDo: [:each | 
			| node | 
			self visitNode: (node := self currentPlayerClass parseTreeFor: each).
			(variables at: currentMorph)
				at: (self asScriptFlag: each)
				put: #Boolean -> (each = scriptName and: [currentMorph = scriptOwner]).
			(variables at: currentMorph) at: (self asScriptLastTime: each) put: #CUnsignedLong -> 0.
			methods add: node formattedCode].
	self
		withCurrentMorph: scriptOwner
		do: [self compileLoopMethod; compileSetUpMethod].
	self removeTempProgramSubclass;
		compileTempProgramSubclass.
	^ self programClass translatedToArduinoC: #main named: scriptName! !

!ArduinoPlayerTranslator methodsFor: 'creating parse nodes' stamp: 'Richo 8/16/2011 13:09'!
variable: variableName
	^ RBVariableNode named: variableName! !

!ArduinoPlayerTranslator methodsFor: 'iterating' stamp: 'Richo 8/16/2011 12:27'!
variablesDo: aBlock 
	"Iterates over the variables dictionary taking care of setting the current morph"
	variables
		keysAndValuesDo: [:morph :vars | self
				withCurrentMorph: morph
				do: [vars keysAndValuesDo: aBlock]] ! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 8/15/2011 16:49'!
withCurrentMorph: aMorph do: aBlock
	"It executes the block using the morph argument as our current morph. It also remembers the old morph, so it's safe to nest this expression.
	The current morph is used whenever we need a legal name for a variable/method name. It defines which morph is currently represented by the 'self' variable"
	| old |
	old := currentMorph.
	currentMorph := aMorph.
	aBlock value.
	currentMorph := old! !
